"use strict";

var _chokidar = require("chokidar");

var _chokidar2 = _interopRequireDefault(_chokidar);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _os = require("os");

var _os2 = _interopRequireDefault(_os);

var _tmp = require("tmp");

var _tmp2 = _interopRequireDefault(_tmp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = async function reloady(options) {
  const { path: modulePath, input } = options;

  let state = {
    resolve: undefined
  };

  {
    const pathName = require.resolve(modulePath);
    const watcher = _chokidar2.default.watch(pathName);
    watcher.on("change", () => {
      state.resolve && state.resolve();
    });
  }
  while (true) {
    try {
      const fn = requireRecached(modulePath);
      await fn(input);
    } catch (e) {
      console.error(e);
    }
    const action = await new Promise(resolve => {
      state.resolve = resolve;
    });
  }
};


function requireRecached(modulePath) {
  if (isRunningInJest()) {
    return requireRecachedJest(modulePath);
  }
  delete require.cache[require.resolve(modulePath)];
  return require(modulePath);
}

function requireRecachedJest(modulePath) {
  const newPath = _tmp2.default.tmpNameSync({ dir: _os2.default.tmpdir() });
  _fs2.default.linkSync(modulePath, newPath);
  return require(newPath);
}

function isRunningInJest() {
  return !!require.requireActual;
}